/********************************** (C) COPYRIGHT *******************************
* File Name          : Compare.C
* Author             : WCH
* Version            : V1.0
* Date               : 2018/08/09
* Description        : CH549 ADCȽ
*******************************************************************************/
#include "Compare.H"
#pragma  NOAREGS
/*******************************************************************************
* Function Name  : CMP_Init
* Description    : Ƚģʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CMP_Init( void )
{
    ADC_CFG |= bCMP_EN;                     //ȽģԴ
    /* Ƚͨѡ,г,ʵʹøݾ */
#if 1
    /* ⲿͨ0ڲ1/8 VDDѹȽ */
    P1_MOD_OC &= ~0x01;                     //P1.0
    P1_DIR_PU &= ~0x01;
    ADC_CFG |= (bADC_AIN_EN | bVDD_REF_EN); //ⲿͨ,οѹ
    ADC_CHAN = (0<<6)|(3<<4)|(0<<0);        //Ƚ-ͨڲͨⲿֱͨ 0,3,0
#endif
#if 0
    /* ⲿͨ0ⲿͨ1ѹȽ */
    P1_MOD_OC &= ~0x03;                     //P1.0 P1.1
    P1_DIR_PU &= ~0x03;
    ADC_CFG |= bADC_AIN_EN;                 //ⲿͨ
    ADC_CHAN = (2<<6)|(3<<4)|(0<<0);        //Ƚ-ͨڲͨⲿֱͨ 2,3,0
#endif
#if 0
    /* ڲ54.5%V33 ⲿͨ1Ƚ */
    P1_MOD_OC &= ~0x02;                     //P1.1
    P1_DIR_PU &= ~0x02;
    ADC_CFG &= ~bADC_AIN_EN;                //رⲿͨ
    ADC_CHAN = (2<<6)|(2<<4)|(0<<0);        //Ƚ-ͨڲͨⲿֱͨ 2,2,0
#endif
    ADC_CTRL = bCMP_IF;                     //Ƚϱ־д1
#if EN_ADC_INT
    SCON2 &= bU2IE;                         //UART2жϵַãж2ѡ1
    IE_ADC = 1;                             //ADCжʹ
    EA = 1;                                 //жʹ
#endif
}
/*******************************************************************************
* Function Name  : CMP_IN_Minus_Signal_SELT
* Description    : ȽIN-ͨźѡ
                   UINT8 mode
                   0:ADC/comparator IN-VDD/8
                   1:ADC/comparator IN-VDD
                   2:ADC/comparator IN-VDD/4
                   3:Ͽڲ,
                   4:ADC/comparator IN-P11
                   5:ADC/comparator IN-P12
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CMP_IN_Minus_Signal_SELT(UINT8 mode)
{
  switch(mode)
  {
    case 0:
      ADC_CFG = ADC_CFG | bVDD_REF_EN | bCMP_EN; //ADC/comparator IN-VDD/8
      ADC_CHAN &= ~MASK_CMP_CHAN;	
    break;	
    case 1:
      ADC_CFG = ADC_CFG | bVDD_REF_EN & ~bCMP_EN; //ADC/comparator IN-VDD
      ADC_CHAN = ADC_CHAN & ~MASK_CMP_CHAN | 0x40;	      			
    break;
    case 2:
      ADC_CFG = ADC_CFG | bVDD_REF_EN | bCMP_EN; //ADC/comparator IN-VDD/4
      ADC_CHAN = ADC_CHAN & ~MASK_CMP_CHAN | 0x40;				
    break;
    case 3:
      ADC_CFG |= bCMP_EN;                        //ADC/comparator IN-P11
      ADC_CHAN = ADC_CHAN & ~MASK_CMP_CHAN | 0x80;			
    break;
    case 4:
      ADC_CFG |= bCMP_EN;                        //ADC/comparator IN-P12
      ADC_CHAN |= MASK_CMP_CHAN;				
    break;
    case 5:
    break;
    default:
    break;			
  }
}
/*******************************************************************************
* Function Name  : CMP_Inter_IN_Plus_Signal_SELT
* Description    : ȽIN+ڲͨźѡ
                   UINT8 mode
                   0:ADC/comparator IN+VDD/2
                   1:ADC/comparator IN+V33
                   2:ADC/comparator IN+V33/1.83
                   3:Ͽڲ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CMP_Inter_IN_Plus_Signal_SELT(UINT8 mode)
{
    ADC_CHAN = ADC_CHAN & ~MASK_ADC_I_CH | (mode<<4);
    if(mode == 0)
    {
        ADC_CFG |= bVDD_REF_EN;
    }
    if(mode == 3)
    {
        ADC_CFG |= bADC_AIN_EN;
    }
}
/*******************************************************************************
* Function Name  : CMP_Ext_IN_Plus_SELT
* Description    : ȽIN+ⲿźͨѡ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CMP_Ext_IN_Plus_SELT(UINT8 ch)
{
    ADC_CFG |= bADC_AIN_EN;
    ADC_CHAN = ADC_CHAN & ~MASK_ADC_CHAN | ch;
}
/*******************************************************************************
* Function Name  : CMP_Ext_IN_Plus_Float
* Description    : ȽIN+ⲿźͨø
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void CMP_Ext_IN_Plus_Float( )
{
    ADC_CFG &= ~bADC_AIN_EN;
}
#if EN_ADC_INT
/*******************************************************************************
* Function Name  : ADC_ISR( )
* Description    : ADC жϷ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void ADC_ISR(void)  interrupt INT_NO_ADC
{
    if(ADC_CTRL&bCMP_IF)
    {
        ADC_CTRL = bCMP_IF;                 //Ƚ仯жϱ־
        if(ADC_CTRL&bCMPDO)
        {
            printf("+ > -\n");
        }
        else
        {
            printf("+ < -\n");
        }
    }
}
#endif
