/********************************** (C) COPYRIGHT *******************************
* File Name          : GPIO.C
* Author             : WCH
* Version            : V1.0
* Date               : 2018/08/09
* Description        : CH549 GPIOغ
*******************************************************************************/
#include ".\GPIO\GPIO.H"
#pragma  NOAREGS
/*******************************************************************************
* Function Name  : GPIO_Init(UINT8 PORTx,UINT8 PINx,UINT8 MODEx)
* Description    : GPIO˿ڳʼ
* Input          : PORTx:0~4
*                  PINx:λ,ÿλӦPortһ
*                  MODEx:
*                        0:ģʽû
*                        1:ģʽжԳսϴ
*                        2:©ָ֧룬û
*                        3:׼˫ģʽ(׼ 8051)©֧룬(Ĭģʽ)
* Output         : None
* Return         : None
*******************************************************************************/
void GPIO_Init(UINT8 PORTx,UINT8 PINx,UINT8 MODEx)
{
    UINT8 Px_DIR_PU,Px_MOD_OC;
    switch(PORTx)                                         //ʼֵ
    {
    case PORT0:
        Px_MOD_OC = P0_MOD_OC;
        Px_DIR_PU = P0_DIR_PU;
        break;
    case PORT1:
        Px_MOD_OC = P1_MOD_OC;
        Px_DIR_PU = P1_DIR_PU;
        break;
    case PORT2:
        Px_MOD_OC = P2_MOD_OC;
        Px_DIR_PU = P2_DIR_PU;
        break;
    case PORT3:
        Px_MOD_OC = P3_MOD_OC;
        Px_DIR_PU = P3_DIR_PU;
        break;
    case PORT4:
        Px_MOD_OC = P4_MOD_OC;
        Px_DIR_PU = P4_DIR_PU;
        break;
    default :
        break;
    }
    switch(MODEx)
    {
    case MODE0:                                       //ģʽû
        Px_MOD_OC &= ~PINx;
        Px_DIR_PU &= ~PINx;
        break;
    case MODE1:                                       //ģʽжԳսϴ
        Px_MOD_OC &= ~PINx;
        Px_DIR_PU |= PINx;
        break;
    case MODE2:                                       //©ָ֧룬û
        Px_MOD_OC |= PINx;
        Px_DIR_PU &= ~PINx;
        break;
    case MODE3:                                       //׼˫ģʽ(׼ 8051)©֧룬
        Px_MOD_OC |= PINx;
        Px_DIR_PU |= PINx;
        break;
    default :
        break;
    }
    switch(PORTx)                                         //д
    {
    case PORT0:
        P0_MOD_OC = Px_MOD_OC;
        P0_DIR_PU = Px_DIR_PU;
        break;
    case PORT1:
        P1_MOD_OC = Px_MOD_OC;
        P1_DIR_PU = Px_DIR_PU;
        break;
    case PORT2:
        P2_MOD_OC = Px_MOD_OC;
        P2_DIR_PU = Px_DIR_PU;
        break;
    case PORT3:
        P3_MOD_OC = Px_MOD_OC;
        P3_DIR_PU = Px_DIR_PU;
        break;
    case PORT4:
        P4_MOD_OC = Px_MOD_OC;
        P4_DIR_PU = Px_DIR_PU;
        break;
    default :
        break;
    }
}
/*******************************************************************************
* Function Name  : GPIO_INT_Init
* Description    :  RXD1_LP15_LP14_LP03_LP57_HP46_LRXD0_L չŵⲿж
*                  ͬʱC51 INT1_LINT0_L ⲿжϴ
*                  (RXD1_LRXD0_LĸȡǷӳ)
* Input          : IntSrc:9ⲿжϣλʾ嶨GPIO.H
*                  Mode0ƽģʽ   1ģʽ (עչŵжģʽͳһõ)
*                  NewState0رնӦⲿжʹ  1Ӧⲿж
* Output         : None
* Return         : None
*******************************************************************************/
void GPIO_INT_Init( UINT16 IntSrc,UINT8 Mode,UINT8 NewState )
{
    /* жϴģʽ */
    if(Mode == INT_EDGE)                                //شģʽ
    {
        if(IntSrc & 0x7F)                               //չж
        {
            GPIO_IE |= bIE_IO_EDGE;
        }
        if(IntSrc&INT_INT0_L)                           //ⲿж0
        {
            IT0 = 1;
        }
        if(IntSrc&INT_INT1_L)                           //ⲿж1
        {
            IT1 = 1;
        }
    }
    else                                                //ƽģʽ
    {
        if(IntSrc & 0x7F)                               //չж
        {
            GPIO_IE &= ~bIE_IO_EDGE;
        }
        if(IntSrc&INT_INT0_L)                           //ⲿж0
        {
            IT0 = 1;
        }
        if(IntSrc&INT_INT1_L)                           //ⲿж1
        {
            IT1 = 1;
        }
    }
    /* жʹ״̬ */
    if(NewState == Enable)                              //ⲿж
    {
        GPIO_IE |= ((UINT8)IntSrc&0x7F);
        if(IntSrc&INT_INT0_L)                           //ⲿж0
        {
            EX0 = 1;
        }
        if(IntSrc&INT_INT1_L)                           //ⲿж1
        {
            EX1 = 1;
        }
        if(GPIO_IE&0x7F)
        {
            IE_GPIO = 1;                                //չGPIOж
        }
        EA = 1;                                         //ж
    }
    else                                                //رնӦⲿж
    {
        GPIO_IE &= ~((UINT8)IntSrc&0x7F);
        if(IntSrc&INT_INT0_L)                           //ⲿж0
        {
            EX0 = 0;
        }
        if(IntSrc&INT_INT1_L)                           //ⲿж1
        {
            EX1 = 0;
        }
        if((GPIO_IE&0x7F)== 0)
        {
            IE_GPIO = 0;                                //رչGPIOж
        }
    }
}
/*******************************************************************************
* Function Name  : GPIO_ISR
* Description    : RXD1P15P14P03P57P46RXD0 ⲿжϷ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
//void GPIO_EXT_ISR(void) interrupt INT_NO_GPIO
//{
//    if(AIN11==0)
//    {
//        mDelaymS(10);
//        printf("P03 Falling\n");
//    }

//    if(AIN5==0)
//    {
//        mDelaymS(10);
//        printf("P15 Falling\n");
//    }


//}
/*******************************************************************************
* Function Name  : GPIO_STD0_ISR
* Description    : INT0(P32) ⲿжϷ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
//void GPIO_STD0_ISR(void) interrupt INT_NO_INT0
//{
//    mDelaymS(10);
//    printf("P32 Falling\n");

//}
/*******************************************************************************
* Function Name  : GPIO_STD1_ISR
* Description    : INT1(P33) ⲿжϷ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
//void GPIO_STD1_ISR(void) interrupt INT_NO_INT1
//{
//    mDelaymS(10);
//    printf("P33 Falling\n");

//}

void GPIO_STD3_ISR(void) interrupt INT_NO_INT3
{
		mDelaymS(10);
    printf("P37 Falling\n");
}